//  The employee class
//
//  Includes (most) information about an employee.  The data fields
//  are protected from modification by the application.

class Empl {
    char fname[20], lname[20];
    char ssn[12];
    char title[25], group[16];
    float salary;
  public:
    Empl();			// Default constructor
    Empl(char *fn, char *ln);	// Additional constructor
    ~Empl();			// Destructor
    void Print();
    void Update(float sal);
    void Update(float sal, char *newtitle);
    void Update(char *fn, char *ln);

    // Returns the new salary value
    float Raise(float percent)	{ return (salary *= percent); }

    //	Functions to set the values of the data fields
    //    The strncpy() relies on all fields being zero'd by the
    //    constructor.
    void SetSalary(float sal)	{ salary = sal; }
    void SetFname(char *fn)	{ strncpy(fname, fn, sizeof(fname)-1); }
    void SetLname(char *ln)	{ strncpy(lname, ln, sizeof(lname)-1); }
    void SetSsn(char *s)	{ strncpy(ssn, s, sizeof(ssn)-1); }
    void SetTitle(char *t)	{ strncpy(title, t, sizeof(title)-1); }
    void SetGroup(char *grp)	{ strncpy(group, grp, sizeof(group)-1); }

    //	Functions to retrieve the data fields' values.
    const float GetSalary()		{ return salary; }
    const char* GetFname()		{ return fname; }
    const char* GetLname()		{ return lname; }
    const char* GetSsn()		{ return ssn; }
    const char* GetTitle()		{ return title; }
    const char* GetGroup()		{ return group; }
};

class Cler : public Empl {
    // Add the contents of the clerical class.
    // Don't forget to redefine Print() to include the new fields.
};

class Tech : public Empl {
    // Add the contents of the technical class.
    // Don't forget to redefine Print() to include the new fields.
};
