#ifndef PHONELIST_H_
#define PHONELIST_H_

#include <iostream.h>
#include <iomanip.h>
#include "sllist.h"

struct Record {
    char name[30+1];
    char number[12+1];
    void Print();		// How to print the Record
};

class PhoneListIter;		// forward declaration

class PhoneList {
    friend class PhoneListIter;
    List head;			// uses a linked list...
  public:
    PhoneList();
    ~PhoneList();		// Destructor must free memory
    void Add(Record *r);	// Adds to head of chain
    void Remove(Record *r);	// Removes from chain
};

class PhoneListIter {
    PhoneList &parent;	// reference to the parent object
    List *current;	// current element in list
  public:
    PhoneListIter(PhoneList &p);
    Record *Current();
    Record *Next();
    void Reset();	// reset back to the beginning
};

#endif // PHONELIST_H_
